## xeus-python 0.15.9+~0.6.0

=== CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Martin Renou, Johan Mabille, Sylvain Corlay, and     #
# Wolf Vollprecht                                                          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

cmake_minimum_required(VERSION 3.4.3)
project(xeus-python)

set(XEUS_PYTHON_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)

# Versionning
# ===========

file(STRINGS "${XEUS_PYTHON_INCLUDE_DIR}/xeus-python/xeus_python_config.hpp" xpyt_version_defines
     REGEX "#define XPYT_VERSION_(MAJOR|MINOR|PATCH)")
foreach (ver ${xpyt_version_defines})
    if (ver MATCHES "#define XPYT_VERSION_(MAJOR|MINOR|PATCH) +([^ ]+)$")
        set(XPYT_VERSION_${CMAKE_MATCH_1} "${CMAKE_MATCH_2}" CACHE INTERNAL "")
    endif ()
endforeach ()
set(${PROJECT_NAME}_VERSION
    ${XPYT_VERSION_MAJOR}.${XPYT_VERSION_MINOR}.${XPYT_VERSION_PATCH})
message(STATUS "Building xeus-python v${${PROJECT_NAME}_VERSION}")

# Configuration
# =============

include(GNUInstallDirs)

if (NOT DEFINED XPYTHON_KERNELSPEC_PATH)
    set(XPYTHON_KERNELSPEC_PATH "${CMAKE_INSTALL_FULL_BINDIR}/")
endif ()

# Running find_package(PythonInterp) to retrieve the Python version
# which is not exported by Pybind11's cmake.
# Cf. https://github.com/pybind/pybind11/issues/2268
find_package(PythonInterp ${PythonLibsNew_FIND_VERSION} REQUIRED)

configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json"
)
configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json"
)

# Build options
# =============

# Compilation options

OPTION(XPYT_ENABLE_PYPI_WARNING "Enable warning on PyPI wheels" OFF)

option(XPYT_BUILD_STATIC "Build xeus-python static library" ON)
OPTION(XPYT_BUILD_SHARED "Split xpython build into executable and library" ON)
OPTION(XPYT_BUILD_XPYTHON_EXECUTABLE "Build the xpython executable" ON)
OPTION(XPYT_BUILD_XPYTHON_EXTENSION "Build the xpython extension module" OFF)

OPTION(XPYT_USE_SHARED_XEUS "Link xpython or xpython_extension with the xeus shared library (instead of the static library)" ON)
OPTION(XPYT_USE_SHARED_XEUS_PYTHON "Link xpython and xpython_extension with the xeus-python shared library (instead of the static library)" ON)

OPTION(XPYT_EMSCRIPTEN_WASM_BUILD "Build for wasm with emscripten" OFF)

# Test options
OPTION(XPYT_BUILD_TESTS "xeus-python test suite" OFF)

if(XPYT_EMSCRIPTEN_WASM_BUILD)
    configure_file(wasm_patches/post.js ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)

    add_compile_definitions(XPYT_EMSCRIPTEN_WASM_BUILD)

    set(XPYT_BUILD_STATIC OFF)
    set(XPYT_BUILD_SHARED OFF)
    set(XPYT_BUILD_XPYTHON_EXECUTABLE OFF)
    set(XPYT_BUILD_XPYTHON_EXTENSION OFF)
    set(XPYT_USE_SHARED_XEUS OFF)
    set(XPYT_USE_SHARED_XEUS_PYTHON OFF)
    set(XPYT_BUILD_TESTS OFF)
endif()

# Dependencies
# ============

set(xtl_REQUIRED_VERSION 0.7.0)
set(xeus-zmq_REQUIRED_VERSION 1.0.1)
set(xeus-lite_REQUIRED_VERSION 1.0.1)
set(pybind11_REQUIRED_VERSION 2.6.1)
set(pybind11_json_REQUIRED_VERSION 0.2.8)
set(pyjs_REQUIRED_VERSION 1.0.0)

if (NOT TARGET xtl)
    find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
endif ()
if (NOT TARGET pybind11::headers)
    find_package(pybind11 ${pybind11_REQUIRED_VERSION} REQUIRED)
endif ()
if (NOT TARGET pybind11_json)
    find_package(pybind11_json ${pybind11_json_REQUIRED_VERSION} REQUIRED)
endif ()

if(XPYT_EMSCRIPTEN_WASM_BUILD)
    if (NOT TARGET xeus-lite)
        find_package(xeus-lite ${xeus-lite_REQUIRED_VERSION} REQUIRED)
    endif ()
    if (NOT TARGET pyjs)
        find_package(pyjs ${pyjs_REQUIRED_VERSION} REQUIRED)
    endif ()
    configure_file(${pyjs_PRE_JS_PATH} ${CMAKE_CURRENT_BINARY_DIR}/pre.js COPYONLY)
    # we can ignore this file, as the xeus-specific post.js contains everything from
    # TODO Move the post.js/pre.js from pyjs that is not specific to Python in xeus-lite
    # pyjs post.js
    # configure_file(${pyjs_POST_JS_PATH} ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)
else ()
    if (NOT TARGET xeus-zmq AND NOT TARGET xeus-zmq-static)
        find_package(xeus-zmq ${xeus-zmq_REQUIRED_VERSION} REQUIRED)
    endif ()
endif()

# Flags
# =====

include(CheckCXXCompilerFlag)

if (MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251 /wd4141")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4018 /wd4267 /wd4715 /wd4146 /wd4129")
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-parameter -Wextra -Wreorder")

    CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)

    if (HAS_CPP14_FLAG)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
    else ()
        message(FATAL_ERROR "Unsupported compiler -- xeus requires C++14 support!")
    endif ()
endif ()

# Source files
# ============

set(XEUS_PYTHON_SRC
    src/xcomm.cpp
    src/xcomm.hpp
    src/xdebugger.cpp
    src/xdebugpy_client.hpp
    src/xdebugpy_client.cpp
    src/xdisplay.cpp
    src/xdisplay.hpp
    src/xinput.cpp
    src/xinput.hpp
    src/xinspect.cpp
    src/xinspect.hpp
    src/xinternal_utils.cpp
    src/xinternal_utils.hpp
    src/xinterpreter.cpp
    src/xinterpreter_raw.cpp
    src/xkernel.cpp
    src/xkernel.hpp
    src/xpaths.cpp
    src/xstream.cpp
    src/xstream.hpp
    src/xtraceback.cpp
    src/xutils.cpp
)

set(XEUS_PYTHON_HEADERS
    include/xeus-python/xdebugger.hpp
    include/xeus-python/xeus_python_config.hpp
    include/xeus-python/xpaths.hpp
    include/xeus-python/xinterpreter.hpp
    include/xeus-python/xinterpreter_raw.hpp
    include/xeus-python/xtraceback.hpp
    include/xeus-python/xutils.hpp
)

set(XPYTHON_SRC
    src/main.cpp
)

set(XPYTHON_EXTENSION_SRC
    src/xpython_extension.cpp
)

set(XEUS_PYTHON_WASM_SRC
    src/xcomm.cpp
    src/xcomm.hpp
    src/xdisplay.cpp
    src/xdisplay.hpp
    src/xinput.cpp
    src/xinput.hpp
    src/xinspect.cpp
    src/xinspect.hpp
    src/xinternal_utils.cpp
    src/xinternal_utils.hpp
    src/xinterpreter.cpp
    src/xinterpreter_wasm.cpp
    src/xkernel.cpp
    src/xkernel.hpp
    src/xpaths.cpp
    src/xstream.cpp
    src/xstream.hpp
    src/xtraceback.cpp
    src/xutils.cpp
)

set(XEUS_PYTHON_WASM_HEADERS
    include/xeus-python/xdebugger.hpp
    include/xeus-python/xeus_python_config.hpp
    include/xeus-python/xpaths.hpp
    include/xeus-python/xinterpreter.hpp
    include/xeus-python/xinterpreter_wasm.hpp
    include/xeus-python/xtraceback.hpp
    include/xeus-python/xutils.hpp
)

set(XPYTHON_WASM_SRC
    src/main_wasm.cpp
)

# Targets and link - Macros
# =========================

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

macro(xpyt_set_common_options target_name)
    if (MSVC)
        target_compile_options(${target_name} PUBLIC /wd4251 /wd4141)
        target_compile_options(${target_name} PUBLIC /wd4018 /wd4267 /wd4715 /wd4146 /wd4129)
    endif ()

    if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
        CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR
        CMAKE_CXX_COMPILER_ID MATCHES "Intel")

        target_compile_options(${target_name} PUBLIC -Wunused-parameter -Wextra -Wreorder)

        # C++14 flag
        CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)
        if (HAS_CPP14_FLAG)
            target_compile_features(${target_name} PRIVATE cxx_std_14)
        else ()
            message(FATAL_ERROR "Unsupported compiler -- xeus-python requires C++14 support!")
        endif ()
    endif ()
endmacro()

# Common macro kernels (xpython and xpython_extension)
macro(xpyt_set_kernel_options target_name)
    if(XPYT_ENABLE_PYPI_WARNING)
        message(STATUS "Enabling PyPI warning for target: " ${target_name})
        target_compile_definitions(${target_name} PRIVATE XEUS_PYTHON_PYPI_WARNING)
    endif()
endmacro()

# Common macro for linking targets
macro(xpyt_target_link_libraries target_name)
    if (XPYT_USE_SHARED_XEUS_PYTHON)
        target_link_libraries(${target_name} PRIVATE xeus-python)

        if(CMAKE_DL_LIBS)
            target_link_libraries(${target_name} PRIVATE ${CMAKE_DL_LIBS} util)
        endif()
    else ()
        target_compile_definitions(${target_name} PUBLIC "XEUS_PYTHON_STATIC_LIB")
        target_link_libraries(${target_name} PRIVATE xeus-python-static)
    endif()

    find_package(Threads) # TODO: add Threads as a dependence of xeus or xeus-static?
    target_link_libraries(${target_name} PRIVATE ${CMAKE_THREAD_LIBS_INIT})
    set_target_properties(${target_name} PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
endmacro()

# Common macro for shared and static library xeus-python
macro(xpyt_create_target target_name src headers linkage output_name)
    string(TOUPPER "${linkage}" linkage_upper)

    if (NOT ${linkage_upper} MATCHES "^(SHARED|STATIC)$")
        message(FATAL_ERROR "Invalid library linkage: ${linkage}")
    endif ()

    add_library(${target_name} ${linkage_upper} ${src} ${headers})
    xpyt_set_common_options(${target_name})

    set_target_properties(${target_name} PROPERTIES
                          PUBLIC_HEADER "${headers}"
                          PREFIX ""
                          VERSION ${${PROJECT_NAME}_VERSION}
                          SOVERSION ${XPYT_VERSION_MAJOR}
                          OUTPUT_NAME "lib${output_name}")

    if (${linkage_upper} STREQUAL "STATIC")
        target_compile_definitions(${target_name} PUBLIC "XEUS_PYTHON_STATIC_LIB")
    else ()
        target_compile_definitions(${target_name} PUBLIC "XEUS_PYTHON_EXPORTS")
    endif ()

    target_include_directories(${target_name}
                               PUBLIC
                               ${PYTHON_INCLUDE_DIRS}
                               $<BUILD_INTERFACE:${XEUS_PYTHON_INCLUDE_DIR}>
                               $<INSTALL_INTERFACE:include>)

    if (XPYT_EMSCRIPTEN_WASM_BUILD)
        set(XPY_XEUS_TARGET xeus)
    elseif (XPYT_USE_SHARED_XEUS)
        set(XPYT_XEUS_TARGET xeus-zmq)
    else ()
        set(XPYT_XEUS_TARGET xeus-zmq-static)
    endif ()

    target_link_libraries(${target_name} PUBLIC ${XPYT_XEUS_TARGET} xtl PRIVATE pybind11::pybind11 pybind11_json)
    if (WIN32 OR CYGWIN)
        target_link_libraries(${target_name} PRIVATE ${PYTHON_LIBRARIES})
    elseif (APPLE)
        target_link_libraries(${target_name} PRIVATE "-undefined dynamic_lookup")
    endif ()

    find_package(Threads) # TODO: add Threads as a dependence of xeus-static?
    target_link_libraries(${target_name} PRIVATE ${CMAKE_THREAD_LIBS_INIT})

    if (XEUS_PYTHONHOME_RELPATH)
        target_compile_definitions(${target_name} PRIVATE XEUS_PYTHONHOME_RELPATH=${XEUS_PYTHONHOME_RELPATH})
    elseif (XEUS_PYTHONHOME_ABSPATH)
        target_compile_definitions(${target_name} PRIVATE XEUS_PYTHONHOME_ABSPATH=${XEUS_PYTHONHOME_ABSPATH})
    endif ()
endmacro ()

# xeus-python
# ===========

set(XEUS_PYTHON_TARGETS "")

if (XPYT_BUILD_SHARED)
    # Build libraries
    xpyt_create_target(xeus-python "${XEUS_PYTHON_SRC}" "${XEUS_PYTHON_HEADERS}" SHARED xeus-python)
    list(APPEND XEUS_PYTHON_TARGETS xeus-python)
endif ()

if (XPYT_BUILD_STATIC)
    # On Windows, a static library should use a different output name
    # to avoid the conflict with the import library of a shared one.
    if (CMAKE_HOST_WIN32)

=== debian/changelog ===
xeus-python (0.15.9+~0.6.0-1) unstable; urgency=medium

  * New upstream version 0.15.9+~0.6.0
  * d/control: switch dependency from xeus-dev to xeus-zmq-dev
  * d/control: add dependency on doctest-dev

 -- Gordon Ball <gordon@chronitis.net>  Mon, 07 Aug 2023 07:50:11 +0000

## xeus-python 0.15.10+~0.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -70,8 +70,17 @@
 # Test options
 OPTION(XPYT_BUILD_TESTS "xeus-python test suite" OFF)
 
+function(cat IN_FILE OUT_FILE)
+  file(READ ${IN_FILE} CONTENTS)
+  file(APPEND ${OUT_FILE} "\n${CONTENTS}")
+endfunction()
+
+
 if(XPYT_EMSCRIPTEN_WASM_BUILD)
-    configure_file(wasm_patches/post.js ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)
+    # Prepare a temporary file to "post.js.in" to
+    # merge xeus custom post js and the pyjs post js
+    file(WRITE post.js.in "")
+    cat(wasm_patches/post.js  post.js.in)
 
     add_compile_definitions(XPYT_EMSCRIPTEN_WASM_BUILD)
 
@@ -92,7 +101,7 @@
 set(xeus-lite_REQUIRED_VERSION 1.0.1)
 set(pybind11_REQUIRED_VERSION 2.6.1)
 set(pybind11_json_REQUIRED_VERSION 0.2.8)
-set(pyjs_REQUIRED_VERSION 1.0.0)
+set(pyjs_REQUIRED_VERSION 1.3.2)
 
 if (NOT TARGET xtl)
     find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
@@ -112,10 +121,8 @@
         find_package(pyjs ${pyjs_REQUIRED_VERSION} REQUIRED)
     endif ()
     configure_file(${pyjs_PRE_JS_PATH} ${CMAKE_CURRENT_BINARY_DIR}/pre.js COPYONLY)
-    # we can ignore this file, as the xeus-specific post.js contains everything from
-    # TODO Move the post.js/pre.js from pyjs that is not specific to Python in xeus-lite
-    # pyjs post.js
-    # configure_file(${pyjs_POST_JS_PATH} ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)
+    cat(${pyjs_POST_JS_PATH}  post.js.in)
+    configure_file( post.js.in  ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)
 else ()
     if (NOT TARGET xeus-zmq AND NOT TARGET xeus-zmq-static)
         find_package(xeus-zmq ${xeus-zmq_REQUIRED_VERSION} REQUIRED)

=== test/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016, Martin Renou, Johan Mabille, Sylvain Corlay, and     #
# Wolf Vollprecht                                                          #
# Copyright (c) 2016, QuantStack                                           #
#                                                                          #
# Distributed under the terms of the BSD 3-Clause License.                 #
#                                                                          #
# The full license is in the file LICENSE, distributed with this software. #
############################################################################

# Unit tests
# ==========

cmake_minimum_required(VERSION 3.1)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    project(xeus-python-test)

    enable_testing()

    find_package(xeus-python REQUIRED CONFIG)
endif ()

message(STATUS "Forcing tests build type to Release")
set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)

include(CheckCXXCompilerFlag)

string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)

if(CMAKE_CXX_COMPILER_ID MATCHES Clang OR CMAKE_CXX_COMPILER_ID MATCHES GNU OR CMAKE_CXX_COMPILER_ID MATCHES Intel)
    add_compile_options(-Wunused-parameter -Wextra -Wreorder -Wconversion -Wsign-conversion)

    CHECK_CXX_COMPILER_FLAG(-march=native HAS_MARCH_NATIVE)
    if (HAS_MARCH_NATIVE)
        add_compile_options(-march=native)
    endif()
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES MSVC)
    add_compile_options(/EHsc /MP /bigobj)
    set(CMAKE_EXE_LINKER_FLAGS /MANIFEST:NO)
endif()

find_package(Threads)
find_package(doctest)

include_directories(${GTEST_INCLUDE_DIRS} SYSTEM)

set(XEUS_PYTHON_TESTS
    main.cpp
    ../src/xutils.cpp
    test_debugger.cpp
    xeus_client.hpp
    xeus_client.cpp
)

add_executable(test_xeus_python ${XEUS_PYTHON_TESTS})

if (APPLE)
    set_target_properties(test_xeus_python PROPERTIES
        MACOSX_RPATH ON
    )
endif()

set_target_properties(test_xeus_python PROPERTIES
    INSTALL_RPATH_USE_LINK_PATH TRUE
)

include_directories(${PYTHON_INCLUDE_DIRS})
target_link_libraries(test_xeus_python ${PYTHON_LIBRARIES} xeus-zmq doctest::doctest ${CMAKE_THREAD_LIBS_INIT})
target_include_directories(test_xeus_python PRIVATE ${XEUS_PYTHON_INCLUDE_DIR})

add_custom_target(xtest COMMAND test_xeus_python DEPENDS test_xeus_python)

=== debian/changelog ===
xeus-python (0.15.10+~0.6.1-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:46:47 +1100

xeus-python (0.15.10+~0.6.1-2build1) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 03 Mar 2024 05:53:56 +0100

xeus-python (0.15.10+~0.6.1-2) unstable; urgency=medium

  * d/control: build-depend on nlohmann-json3-dev 3.11.3, xeus-zmq 1.1.1-2;
    this should resolve an ABI issue caused by xeus exposing nlohmann::json
    (Closes: #1061007)

 -- Gordon Ball <gordon@chronitis.net>  Sun, 11 Feb 2024 22:27:04 +0100

xeus-python (0.15.10+~0.6.1-1) unstable; urgency=medium

  * New upstream version 0.15.10+~0.6.1

 -- Gordon Ball <gordon@chronitis.net>  Thu, 05 Oct 2023 12:43:30 +0000

=== debian/control ===
Source: xeus-python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               cmake,
               pkg-config,
               libzmq3-dev,
               xeus-zmq-dev (>= 1.1.1-2~),
               xtl-dev (>= 0.7~),
               nlohmann-json3-dev (>= 3.11.3~),
               pybind11-dev (>= 2.10.3~),
               pybind11-json-dev (>= 0.2.8~),
               doctest-dev,
               python3-dev,
               python3-setuptools,
Standards-Version: 4.6.2
Section: science
Homepage: https://github.com/jupyter-xeus/xeus-python
Vcs-Git: https://salsa.debian.org/science-team/xeus-python.git
Vcs-Browser: https://salsa.debian.org/science-team/xeus-python
Rules-Requires-Root: no

Package: xeus-python-dev
Architecture: any
Depends: ${misc:Depends},
         libxeus-python0 (= ${binary:Version}),
         xeus-zmq-dev,
         pybind11-dev,
         pybind11-json-dev,
         python3-dev,
Description: Native jupyter kernel for python (headers)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the development headers.

Package: libxeus-python0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: Native jupyter kernel for python (library)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the library.

Package: xpython
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3-xeus-python-shell,
Description: Native jupyter kernel for python (binary)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the xpython executable and jupyter kernel configuration.

Package: python3-xeus-python-shell
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: Native jupyter kernel for python (python library)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the python library used for the shell.

## xeus-python 0.17.2+~0.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,13 +8,13 @@
 # The full license is in the file LICENSE, distributed with this software. #
 ############################################################################
 
-cmake_minimum_required(VERSION 3.4.3)
+cmake_minimum_required(VERSION 3.20)
 project(xeus-python)
 
 set(XEUS_PYTHON_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
 
-# Versionning
-# ===========
+# Versioning
+# ==========
 
 file(STRINGS "${XEUS_PYTHON_INCLUDE_DIR}/xeus-python/xeus_python_config.hpp" xpyt_version_defines
      REGEX "#define XPYT_VERSION_(MAJOR|MINOR|PATCH)")
@@ -36,10 +36,15 @@
     set(XPYTHON_KERNELSPEC_PATH "${CMAKE_INSTALL_FULL_BINDIR}/")
 endif ()
 
-# Running find_package(PythonInterp) to retrieve the Python version
-# which is not exported by Pybind11's cmake.
-# Cf. https://github.com/pybind/pybind11/issues/2268
-find_package(PythonInterp ${PythonLibsNew_FIND_VERSION} REQUIRED)
+if(EMSCRIPTEN)
+    # the variables PYTHON_VERSION_MAJOR and PYTHON_VERSION_MINOR
+    # might be wrong for the EMSCRIPTEN case since it may contains
+    # the versions of build-python and not the one of the host.
+    FILE(GLOB WASM_PYTHON_LIBRARY  $ENV{PREFIX}/lib/libpython*.a)
+    STRING(REGEX MATCH "python[0-9]+[.][0-9]+" PYTHON_VERSION_STRING ${WASM_PYTHON_LIBRARY})
+    STRING(REGEX MATCH "[0-9]+" PYTHON_VERSION_MAJOR ${PYTHON_VERSION_STRING})
+    STRING(REGEX MATCH "[0-9]+$" PYTHON_VERSION_MINOR ${PYTHON_VERSION_STRING})
+endif()
 
 configure_file (
     "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json.in"
@@ -55,20 +60,20 @@
 
 # Compilation options
 
-OPTION(XPYT_ENABLE_PYPI_WARNING "Enable warning on PyPI wheels" OFF)
+option(XPYT_ENABLE_PYPI_WARNING "Enable warning on PyPI wheels" OFF)
 
 option(XPYT_BUILD_STATIC "Build xeus-python static library" ON)
-OPTION(XPYT_BUILD_SHARED "Split xpython build into executable and library" ON)
-OPTION(XPYT_BUILD_XPYTHON_EXECUTABLE "Build the xpython executable" ON)
-OPTION(XPYT_BUILD_XPYTHON_EXTENSION "Build the xpython extension module" OFF)
-
-OPTION(XPYT_USE_SHARED_XEUS "Link xpython or xpython_extension with the xeus shared library (instead of the static library)" ON)
-OPTION(XPYT_USE_SHARED_XEUS_PYTHON "Link xpython and xpython_extension with the xeus-python shared library (instead of the static library)" ON)
-
-OPTION(XPYT_EMSCRIPTEN_WASM_BUILD "Build for wasm with emscripten" OFF)
+option(XPYT_BUILD_SHARED "Split xpython build into executable and library" ON)
+option(XPYT_BUILD_XPYTHON_EXECUTABLE "Build the xpython executable" ON)
+option(XPYT_BUILD_XPYTHON_EXTENSION "Build the xpython extension module" OFF)
+
+option(XPYT_USE_SHARED_XEUS "Link xpython or xpython_extension with the xeus shared library (instead of the static library)" ON)
+option(XPYT_USE_SHARED_XEUS_PYTHON "Link xpython and xpython_extension with the xeus-python shared library (instead of the static library)" ON)
+
+option(XPYT_EMSCRIPTEN_WASM_BUILD "Build for wasm with emscripten" OFF)
 
 # Test options
-OPTION(XPYT_BUILD_TESTS "xeus-python test suite" OFF)
+option(XPYT_BUILD_TESTS "xeus-python test suite" OFF)
 
 function(cat IN_FILE OUT_FILE)
   file(READ ${IN_FILE} CONTENTS)
@@ -76,7 +81,7 @@
 endfunction()
 
 
-if(XPYT_EMSCRIPTEN_WASM_BUILD)
+if(EMSCRIPTEN)
     # Prepare a temporary file to "post.js.in" to
     # merge xeus custom post js and the pyjs post js
     file(WRITE post.js.in "")
@@ -96,24 +101,25 @@
 # Dependencies
 # ============
 
-set(xtl_REQUIRED_VERSION 0.7.0)
-set(xeus-zmq_REQUIRED_VERSION 1.0.1)
+set(xeus_zmq_REQUIRED_VERSION 3.0.0)
 set(xeus-lite_REQUIRED_VERSION 1.0.1)
 set(pybind11_REQUIRED_VERSION 2.6.1)
 set(pybind11_json_REQUIRED_VERSION 0.2.8)
-set(pyjs_REQUIRED_VERSION 1.3.2)
-
-if (NOT TARGET xtl)
-    find_package(xtl ${xtl_REQUIRED_VERSION} REQUIRED)
-endif ()
+set(pyjs_REQUIRED_VERSION 2.0.0)
+
+find_package(Python COMPONENTS Interpreter REQUIRED)
+
 if (NOT TARGET pybind11::headers)
+    # Defaults to ON for cmake >= 3.18
+    # https://github.com/pybind/pybind11/blob/35ff42b56e9d34d9a944266eb25f2c899dbdfed7/CMakeLists.txt#L96
+    set(PYBIND11_FINDPYTHON OFF)
     find_package(pybind11 ${pybind11_REQUIRED_VERSION} REQUIRED)
 endif ()
 if (NOT TARGET pybind11_json)
     find_package(pybind11_json ${pybind11_json_REQUIRED_VERSION} REQUIRED)
 endif ()
 
-if(XPYT_EMSCRIPTEN_WASM_BUILD)
+if(EMSCRIPTEN)
     if (NOT TARGET xeus-lite)
         find_package(xeus-lite ${xeus-lite_REQUIRED_VERSION} REQUIRED)
     endif ()
@@ -128,28 +134,6 @@
         find_package(xeus-zmq ${xeus-zmq_REQUIRED_VERSION} REQUIRED)
     endif ()
 endif()
-
-# Flags
-# =====
-
-include(CheckCXXCompilerFlag)
-
-if (MSVC)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251 /wd4141")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4018 /wd4267 /wd4715 /wd4146 /wd4129")
-endif ()
-
-if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Intel")
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-parameter -Wextra -Wreorder")
-
-    CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)
-
-    if (HAS_CPP14_FLAG)
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
-    else ()
-        message(FATAL_ERROR "Unsupported compiler -- xeus requires C++14 support!")
-    endif ()
-endif ()
 
 # Source files
 # ============
@@ -236,11 +220,10 @@
 # Targets and link - Macros
 # =========================
 
-include(CheckCXXCompilerFlag)
-
 string(TOUPPER "${CMAKE_BUILD_TYPE}" U_CMAKE_BUILD_TYPE)
 
 macro(xpyt_set_common_options target_name)
+    target_compile_features(${target_name} PRIVATE cxx_std_17)
     if (MSVC)
         target_compile_options(${target_name} PUBLIC /wd4251 /wd4141)
         target_compile_options(${target_name} PUBLIC /wd4018 /wd4267 /wd4715 /wd4146 /wd4129)
@@ -249,16 +232,7 @@
     if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR
         CMAKE_CXX_COMPILER_ID MATCHES "GNU" OR
         CMAKE_CXX_COMPILER_ID MATCHES "Intel")
-
         target_compile_options(${target_name} PUBLIC -Wunused-parameter -Wextra -Wreorder)
-
-        # C++14 flag
-        CHECK_CXX_COMPILER_FLAG("-std=c++14" HAS_CPP14_FLAG)
-        if (HAS_CPP14_FLAG)
-            target_compile_features(${target_name} PRIVATE cxx_std_14)
-        else ()
-            message(FATAL_ERROR "Unsupported compiler -- xeus-python requires C++14 support!")
-        endif ()
     endif ()
 endmacro()
 
@@ -318,7 +292,7 @@
                                $<BUILD_INTERFACE:${XEUS_PYTHON_INCLUDE_DIR}>
                                $<INSTALL_INTERFACE:include>)
 
-    if (XPYT_EMSCRIPTEN_WASM_BUILD)
+    if (EMSCRIPTEN)
         set(XPY_XEUS_TARGET xeus)
     elseif (XPYT_USE_SHARED_XEUS)
         set(XPYT_XEUS_TARGET xeus-zmq)
@@ -326,7 +300,7 @@
         set(XPYT_XEUS_TARGET xeus-zmq-static)
     endif ()
 
-    target_link_libraries(${target_name} PUBLIC ${XPYT_XEUS_TARGET} xtl PRIVATE pybind11::pybind11 pybind11_json)
+    target_link_libraries(${target_name} PUBLIC ${XPYT_XEUS_TARGET} PRIVATE pybind11::pybind11 pybind11_json)
     if (WIN32 OR CYGWIN)
         target_link_libraries(${target_name} PRIVATE ${PYTHON_LIBRARIES})
     elseif (APPLE)
@@ -358,3 +332,18 @@
     # On Windows, a static library should use a different output name
     # to avoid the conflict with the import library of a shared one.
     if (CMAKE_HOST_WIN32)
+        xpyt_create_target(xeus-python-static "${XEUS_PYTHON_SRC}" "${XEUS_PYTHON_HEADERS}" STATIC xeus-python-static)
+    else ()
+        xpyt_create_target(xeus-python-static "${XEUS_PYTHON_SRC}" "${XEUS_PYTHON_HEADERS}" STATIC xeus-python)
+    endif ()
+
+    list(APPEND XEUS_PYTHON_TARGETS xeus-python-static)
+endif ()
+
+if (EMSCRIPTEN)
+    xpyt_create_target(xeus-python-wasm "${XEUS_PYTHON_WASM_SRC}" "${XEUS_PYTHON_WASM_HEADERS}" STATIC xeus-python-wasm)
+    target_compile_options(xeus-python-wasm PRIVATE -fPIC)
+    list(APPEND XEUS_PYTHON_TARGETS xeus-python-wasm)
+
+    target_link_libraries(xeus-python-wasm PRIVATE pyjs)
+

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # Unit tests
 # ==========
 
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.20)
 
 if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
     project(xeus-python-test)
@@ -57,6 +57,8 @@
 
 add_executable(test_xeus_python ${XEUS_PYTHON_TESTS})
 
+target_compile_features(test_xeus_python PRIVATE cxx_std_17)
+
 if (APPLE)
     set_target_properties(test_xeus_python PROPERTIES
         MACOSX_RPATH ON

=== debian/changelog ===
xeus-python (0.17.2+~0.6.3-0.2) unstable; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * debian/control:
   - Remove Build-Depends on xtl-dev
   - Build-Depends on nlohmann-json3.12-dev instead of nlohmann-json3-dev

 -- Bill Allombert <ballombe@debian.org>  Sun, 02 Nov 2025 10:54:03 +0100

xeus-python (0.17.2+~0.6.3-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Bill Allombert <ballombe@debian.org>  Fri, 27 Dec 2024 11:29:11 +0100

xeus-python (0.17.1+~0.6.3-0.2) experimental; urgency=medium

  * Non-maintainer upload.
  * debian/control: add Build-Depends on xeus-dev (>= 5.0.0)

 -- Bill Allombert <ballombe@debian.org>  Fri, 01 Nov 2024 20:31:52 +0100

xeus-python (0.17.1+~0.6.3-0.1) experimental; urgency=medium

  * Non-maintainer upload by request from Gordon.
    - patch no-install-dot-cmake: do no install the .cmake files.
  * debian/control:
    - Build-Depends on pkgconf instead of pkg-config
    - Build-Depends on xeus-zmq-dev (>= 3.0.0)
    - remove useless packages xeus-python-dev and libxeus-python0.
  * debian/xeus-python-dev.install, debian/libxeus-python0.install:
    removed.
  * debian/rules:
    - add override_dh_clean to fix clean target
    - dh_auto_configure:
      + set -DXPYT_USE_SHARED_XEUS_PYTHON=OFF -DXPYT_BUILD_SHARED=OFF
        to disable building libxeus-python0
      + set -DPYTHON_VERSION_MAJOR=3 -DPYTHON_VERSION_MINOR=11
        to get correct version in kernel.json
  * debian/copyright:
    - update path to SVG images.
    - use public-domain as SPDX identifier for Public domain.

 -- Bill Allombert <ballombe@debian.org>  Fri, 01 Nov 2024 11:45:27 +0100

=== debian/control ===
Source: xeus-python
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               cmake,
               pkgconf,
               libzmq3-dev,
               xeus-zmq-dev (>= 3.0.0),
               xeus-dev (>= 5.0.0),
               nlohmann-json3.12-dev,
               pybind11-dev (>= 2.10.3~),
               pybind11-json-dev (>= 0.2.8~),
               doctest-dev,
               python3-dev,
               python3-setuptools,
Standards-Version: 4.6.2
Section: science
Homepage: https://github.com/jupyter-xeus/xeus-python
Vcs-Git: https://salsa.debian.org/science-team/xeus-python.git
Vcs-Browser: https://salsa.debian.org/science-team/xeus-python
Rules-Requires-Root: no

Package: xpython
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3-xeus-python-shell,
Description: Native jupyter kernel for python (binary)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the xpython executable and jupyter kernel configuration.

Package: python3-xeus-python-shell
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: Native jupyter kernel for python (python library)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the python library used for the shell.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DPYTHON_EXECUTABLE=/usr/bin/python3 -DXPYT_DISABLE_ARCH_NATIVE=1 -DXPYT_DISABLE_TUNE_GENERIC=1 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON -DXPYT_USE_SHARED_XEUS_PYTHON=OFF -DXPYT_BUILD_SHARED=OFF -DPYTHON_VERSION_MAJOR=3 -DPYTHON_VERSION_MINOR=11
	dh_auto_configure -D xeus-python-shell --buildsystem pybuild

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -D xeus-python-shell --buildsystem pybuild

override_dh_auto_install:
	dh_auto_install
	dh_auto_install -D xeus-python-shell --buildsystem pybuild

override_dh_clean:
	dh_clean
	rm -f share/jupyter/kernels/xpython/kernel.json
	rm -f share/jupyter/kernels/xpython-raw/kernel.json
	rm -rf .pybuild
	rm -rf xeus-python-shell/xeus_python_shell.egg-info

=== debian/tests/control ===
Test-Command: jupyter-nbconvert debian/tests/sample.ipynb --stdout --execute --to markdown
Depends: xpython, python3-ipython, python3-jupyter-client, jupyter-nbconvert
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus-python/tags .*/@ANY_VERSION@@ARCHIVE_EXT@ group

opts="component=xeus-python-shell" https://github.com/jupyter-xeus/xeus-python-shell/tags .*/@ANY_VERSION@@ARCHIVE_EXT@ group

## xeus-python 0.17.6+~0.6.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,86 @@
     ${XPYT_VERSION_MAJOR}.${XPYT_VERSION_MINOR}.${XPYT_VERSION_PATCH})
 message(STATUS "Building xeus-python v${${PROJECT_NAME}_VERSION}")
 
+# Build options
+# =============
+
+# Compilation options
+
+option(XPYT_ENABLE_PYPI_WARNING "Enable warning on PyPI wheels" OFF)
+
+option(XPYT_BUILD_STATIC "Build xeus-python static library" ON)
+option(XPYT_BUILD_SHARED "Split xpython build into executable and library" ON)
+option(XPYT_BUILD_XPYTHON_EXECUTABLE "Build the xpython executable" ON)
+option(XPYT_BUILD_XPYTHON_EXTENSION "Build the xpython extension module" OFF)
+
+option(XPYT_USE_SHARED_XEUS "Link xpython or xpython_extension with the xeus shared library (instead of the static library)" ON)
+option(XPYT_USE_SHARED_XEUS_PYTHON "Link xpython and xpython_extension with the xeus-python shared library (instead of the static library)" ON)
+
+option(XPYT_EMSCRIPTEN_WASM_BUILD "Build for wasm with emscripten" OFF)
+
+# Test options
+option(XPYT_BUILD_TESTS "xeus-python test suite" OFF)
+
+function(cat IN_FILE OUT_FILE)
+  file(READ ${IN_FILE} CONTENTS)
+  file(APPEND ${OUT_FILE} "\n${CONTENTS}")
+endfunction()
+
+
+if(EMSCRIPTEN)
+    # Prepare a temporary file to "post.js.in" to
+    # merge xeus custom post js and the pyjs post js
+    file(WRITE post.js.in "")
+    cat(wasm_patches/post.js  post.js.in)
+
+    add_compile_definitions(XPYT_EMSCRIPTEN_WASM_BUILD)
+    set_property(GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS TRUE)
+
+    set(XPYT_BUILD_STATIC OFF)
+    set(XPYT_BUILD_SHARED OFF)
+    set(XPYT_BUILD_XPYTHON_EXECUTABLE OFF)
+    set(XPYT_BUILD_XPYTHON_EXTENSION OFF)
+    set(XPYT_USE_SHARED_XEUS_PYTHON OFF)
+    set(XPYT_BUILD_TESTS OFF)
+endif()
+
+# Dependencies
+# ============
+
+set(xeus_zmq_REQUIRED_VERSION 3.0.0)
+set(xeus-lite_REQUIRED_VERSION 1.0.1)
+set(pybind11_REQUIRED_VERSION 2.6.1)
+set(pybind11_json_REQUIRED_VERSION 0.2.8)
+set(pyjs_REQUIRED_VERSION 2.0.0)
+
+find_package(Python COMPONENTS Interpreter REQUIRED)
+
+if (NOT TARGET pybind11::headers)
+    # Defaults to ON for cmake >= 3.18
+    # https://github.com/pybind/pybind11/blob/35ff42b56e9d34d9a944266eb25f2c899dbdfed7/CMakeLists.txt#L96
+    set(PYBIND11_FINDPYTHON OFF)
+    find_package(pybind11 ${pybind11_REQUIRED_VERSION} REQUIRED)
+endif ()
+if (NOT TARGET pybind11_json)
+    find_package(pybind11_json ${pybind11_json_REQUIRED_VERSION} REQUIRED)
+endif ()
+
+if(EMSCRIPTEN)
+    if (NOT TARGET xeus-lite)
+        find_package(xeus-lite ${xeus-lite_REQUIRED_VERSION} REQUIRED)
+    endif ()
+    if (NOT TARGET pyjs)
+        find_package(pyjs ${pyjs_REQUIRED_VERSION} REQUIRED)
+    endif ()
+    configure_file(${pyjs_PRE_JS_PATH} ${CMAKE_CURRENT_BINARY_DIR}/pre.js COPYONLY)
+    cat(${pyjs_POST_JS_PATH}  post.js.in)
+    configure_file( post.js.in  ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)
+else ()
+    if (NOT TARGET xeus-zmq AND NOT TARGET xeus-zmq-static)
+        find_package(xeus-zmq ${xeus-zmq_REQUIRED_VERSION} REQUIRED)
+    endif ()
+endif()
+
 # Configuration
 # =============
 
@@ -34,6 +114,16 @@
 
 if (NOT DEFINED XPYTHON_KERNELSPEC_PATH)
     set(XPYTHON_KERNELSPEC_PATH "${CMAKE_INSTALL_FULL_BINDIR}/")
+endif ()
+
+if (NOT DEFINED XPYTHON_DEBUGGER_AVAILABLE)
+    message(STATUS "PYTHON_VERSION = ${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
+    if ((PYTHON_VERSION_MAJOR EQUAL 3) AND (PYTHON_VERSION_MINOR EQUAL 13))
+        set(XPYTHON_DEBUGGER_AVAILABLE "false")
+    else ()
+        set(XPYTHON_DEBUGGER_AVAILABLE "true")
+    endif ()
+    message(STATUS "XPYTHON_DEBUGGER_AVAILABLE=${XPYTHON_DEBUGGER_AVAILABLE}")
 endif ()
 
 if(EMSCRIPTEN)
@@ -44,96 +134,23 @@
     STRING(REGEX MATCH "python[0-9]+[.][0-9]+" PYTHON_VERSION_STRING ${WASM_PYTHON_LIBRARY})
     STRING(REGEX MATCH "[0-9]+" PYTHON_VERSION_MAJOR ${PYTHON_VERSION_STRING})
     STRING(REGEX MATCH "[0-9]+$" PYTHON_VERSION_MINOR ${PYTHON_VERSION_STRING})
+
+    configure_file (
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/wasm_kernel.json.in"
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json"
+    )
+else()
+    configure_file (
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json.in"
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json"
+    )
+    configure_file (
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json.in"
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json"
+    )
 endif()
 
-configure_file (
-    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json.in"
-    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json"
-)
-configure_file (
-    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json.in"
-    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json"
-)
-
-# Build options
-# =============
-
-# Compilation options
-
-option(XPYT_ENABLE_PYPI_WARNING "Enable warning on PyPI wheels" OFF)
-
-option(XPYT_BUILD_STATIC "Build xeus-python static library" ON)
-option(XPYT_BUILD_SHARED "Split xpython build into executable and library" ON)
-option(XPYT_BUILD_XPYTHON_EXECUTABLE "Build the xpython executable" ON)
-option(XPYT_BUILD_XPYTHON_EXTENSION "Build the xpython extension module" OFF)
-
-option(XPYT_USE_SHARED_XEUS "Link xpython or xpython_extension with the xeus shared library (instead of the static library)" ON)
-option(XPYT_USE_SHARED_XEUS_PYTHON "Link xpython and xpython_extension with the xeus-python shared library (instead of the static library)" ON)
-
-option(XPYT_EMSCRIPTEN_WASM_BUILD "Build for wasm with emscripten" OFF)
-
-# Test options
-option(XPYT_BUILD_TESTS "xeus-python test suite" OFF)
-
-function(cat IN_FILE OUT_FILE)
-  file(READ ${IN_FILE} CONTENTS)
-  file(APPEND ${OUT_FILE} "\n${CONTENTS}")
-endfunction()
-
-
-if(EMSCRIPTEN)
-    # Prepare a temporary file to "post.js.in" to
-    # merge xeus custom post js and the pyjs post js
-    file(WRITE post.js.in "")
-    cat(wasm_patches/post.js  post.js.in)
-
-    add_compile_definitions(XPYT_EMSCRIPTEN_WASM_BUILD)
-
-    set(XPYT_BUILD_STATIC OFF)
-    set(XPYT_BUILD_SHARED OFF)
-    set(XPYT_BUILD_XPYTHON_EXECUTABLE OFF)
-    set(XPYT_BUILD_XPYTHON_EXTENSION OFF)
-    set(XPYT_USE_SHARED_XEUS OFF)
-    set(XPYT_USE_SHARED_XEUS_PYTHON OFF)
-    set(XPYT_BUILD_TESTS OFF)
-endif()
-
-# Dependencies
-# ============
-
-set(xeus_zmq_REQUIRED_VERSION 3.0.0)
-set(xeus-lite_REQUIRED_VERSION 1.0.1)
-set(pybind11_REQUIRED_VERSION 2.6.1)
-set(pybind11_json_REQUIRED_VERSION 0.2.8)
-set(pyjs_REQUIRED_VERSION 2.0.0)
-
-find_package(Python COMPONENTS Interpreter REQUIRED)
-
-if (NOT TARGET pybind11::headers)
-    # Defaults to ON for cmake >= 3.18
-    # https://github.com/pybind/pybind11/blob/35ff42b56e9d34d9a944266eb25f2c899dbdfed7/CMakeLists.txt#L96
-    set(PYBIND11_FINDPYTHON OFF)
-    find_package(pybind11 ${pybind11_REQUIRED_VERSION} REQUIRED)
-endif ()
-if (NOT TARGET pybind11_json)
-    find_package(pybind11_json ${pybind11_json_REQUIRED_VERSION} REQUIRED)
-endif ()
-
-if(EMSCRIPTEN)
-    if (NOT TARGET xeus-lite)
-        find_package(xeus-lite ${xeus-lite_REQUIRED_VERSION} REQUIRED)
-    endif ()
-    if (NOT TARGET pyjs)
-        find_package(pyjs ${pyjs_REQUIRED_VERSION} REQUIRED)
-    endif ()
-    configure_file(${pyjs_PRE_JS_PATH} ${CMAKE_CURRENT_BINARY_DIR}/pre.js COPYONLY)
-    cat(${pyjs_POST_JS_PATH}  post.js.in)
-    configure_file( post.js.in  ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)
-else ()
-    if (NOT TARGET xeus-zmq AND NOT TARGET xeus-zmq-static)
-        find_package(xeus-zmq ${xeus-zmq_REQUIRED_VERSION} REQUIRED)
-    endif ()
-endif()
+
 
 # Source files
 # ============
@@ -293,7 +310,7 @@
                                $<INSTALL_INTERFACE:include>)
 
     if (EMSCRIPTEN)
-        set(XPY_XEUS_TARGET xeus)
+        set(XPYT_XEUS_TARGET xeus)
     elseif (XPYT_USE_SHARED_XEUS)
         set(XPYT_XEUS_TARGET xeus-zmq)
     else ()
@@ -330,20 +347,3 @@
 
 if (XPYT_BUILD_STATIC)
     # On Windows, a static library should use a different output name
-    # to avoid the conflict with the import library of a shared one.
-    if (CMAKE_HOST_WIN32)
-        xpyt_create_target(xeus-python-static "${XEUS_PYTHON_SRC}" "${XEUS_PYTHON_HEADERS}" STATIC xeus-python-static)
-    else ()
-        xpyt_create_target(xeus-python-static "${XEUS_PYTHON_SRC}" "${XEUS_PYTHON_HEADERS}" STATIC xeus-python)
-    endif ()
-
-    list(APPEND XEUS_PYTHON_TARGETS xeus-python-static)
-endif ()
-
-if (EMSCRIPTEN)
-    xpyt_create_target(xeus-python-wasm "${XEUS_PYTHON_WASM_SRC}" "${XEUS_PYTHON_WASM_HEADERS}" STATIC xeus-python-wasm)
-    target_compile_options(xeus-python-wasm PRIVATE -fPIC)
-    list(APPEND XEUS_PYTHON_TARGETS xeus-python-wasm)
-
-    target_link_libraries(xeus-python-wasm PRIVATE pyjs)
-

=== debian/changelog ===
xeus-python (0.17.6+~0.6.4-1) unstable; urgency=medium

  * New upstream version 0.17.6+~0.6.4
  * d/patches: rebase
  * d/control: standards-version 4.7.3, drop rules-requires-root, drop priority
  * d/rules: do not hardcode PYTHON_VERSION_MINOR
  * d/watch: upgrade to version 5

 -- Gordon Ball <gordon@chronitis.net>  Tue, 30 Dec 2025 14:16:39 +0000

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,13 @@
 #!/usr/bin/make -f
 
 include /usr/share/dpkg/architecture.mk
+PYMINOR=$(shell python3 -c 'print(__import__("sys").version_info.minor)')
 
 %:
 	dh $@ --with python3
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DPYTHON_EXECUTABLE=/usr/bin/python3 -DXPYT_DISABLE_ARCH_NATIVE=1 -DXPYT_DISABLE_TUNE_GENERIC=1 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON -DXPYT_USE_SHARED_XEUS_PYTHON=OFF -DXPYT_BUILD_SHARED=OFF -DPYTHON_VERSION_MAJOR=3 -DPYTHON_VERSION_MINOR=11
+	dh_auto_configure -- -DPYTHON_EXECUTABLE=/usr/bin/python3 -DXPYT_DISABLE_ARCH_NATIVE=1 -DXPYT_DISABLE_TUNE_GENERIC=1 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON -DXPYT_USE_SHARED_XEUS_PYTHON=OFF -DXPYT_BUILD_SHARED=OFF -DPYTHON_VERSION_MAJOR=3 -DPYTHON_VERSION_MINOR=$(PYMINOR)
 	dh_auto_configure -D xeus-python-shell --buildsystem pybuild
 
 override_dh_auto_build:

=== debian/watch ===
Version: 5

Template: GitHub
Owner: jupyter-xeus
Project: xeus-python
Version-Schema: group

Component: xeus-python-shell
Template: GitHub
Owner: jupyter-xeus
Project: xeus-python-shell
Version-Schema: group
